import bpy
from bpy.props import (StringProperty,
                       BoolProperty,
                       IntProperty,
                       FloatProperty,
                       EnumProperty,
                       PointerProperty,
                       CollectionProperty,
                       FloatVectorProperty
                       )
from . import auto_rigger_panel
from . import bones_pointer
from . import auto_rigger_operator
from . import auto_rigger_settings
from . import auto_rigger_scaler
from . import  auto_rigger_save_rig_file
from . import  auto_rigger_load_file
from . import  auto_rigger_object_panel

bl_info = {
    "name": "Auto IK Rigger V2",
    "description": "Version 2 of Auto Ik Rigger",
    "author": "Daitomodachi, Lateasusual",
    "version": (1, 0, 0),
    "blender": (3, 0, 0),
    "location": "Pose Mode -> Armature Data",
    "warning": "",
    "wiki_url": "",
    "tracker_url": "",
    "support": "COMMUNITY",
    "category": "Rigging"
}


# Initilizes the global variables
auto_rigger_settings.init()


def register():
    bpy.utils.register_class(auto_rigger_operator.RunAutoRig)
    bpy.utils.register_class(auto_rigger_object_panel.OBJECT_PT_AutoRigger_MISC)
    bpy.utils.register_class(auto_rigger_panel.OBJECT_PT_AutoRigger)
    bpy.utils.register_class(auto_rigger_scaler.RunAutoRigRescaler)
    bpy.utils.register_class(bones_pointer.BonesPointer)
    bpy.utils.register_class(auto_rigger_save_rig_file.SaveRigFile)
    bpy.utils.register_class(auto_rigger_load_file.LoadRigFile)
    bpy.types.Scene.ArmatureProp = PointerProperty(type=bones_pointer.BonesPointer)


def unregister():
    bpy.utils.unregister_class(auto_rigger_operator.RunAutoRig)
    bpy.utils.unregister_class(auto_rigger_object_panel.OBJECT_PT_AutoRigger_MISC)
    bpy.utils.unregister_class(auto_rigger_panel.OBJECT_PT_AutoRigger)
    bpy.utils.unregister_class(auto_rigger_scaler.RunAutoRigRescaler)
    bpy.utils.unregister_class(bones_pointer.BonesPointer)
    bpy.utils.unregister_class(auto_rigger_save_rig_file.SaveRigFile)
    bpy.utils.unregister_class(auto_rigger_load_file.LoadRigFile)


if __name__ == "__main__":
    register()
