import bpy
from . import auto_rigger_settings
from os import path

lib_data = None
col_name = 'R4Q Rigger Custom Bone Shapes'

def add_bone_shape(bone_name, bone_shape):
    boner = bpy.data.objects[auto_rigger_settings.Arm_name].pose.bones[bone_name]
    obj = lib_data[bone_shape]
    boner.custom_shape = obj
    bpy.data.objects[auto_rigger_settings.Arm_name].data.bones[bone_name].show_wire = True
    boner.use_custom_shape_bone_size = False


def load_custom_bones(blend_file, section, obj):
    filepath = blend_file + section + obj
    directory = blend_file + section
    filename = obj
    bpy.ops.wm.append(filepath=filepath, filename=filename, directory=directory)

def add_custom_bones():
    # Implement function here
    reference = bpy.context.scene.ArmatureProp

    blendfile = path.join(path.dirname(__file__), "R4Q_Rigger_Bone_Shapes.blend")
    # section = "\\Collection\\"
    # obj = "R4Q Rigger Custom Bone Shapes"

    #  load_custom_bones(blendfile, section, obj)
    with bpy.data.libraries.load(blendfile) as (data_from, data_to):
        data_to.objects = data_from.objects
    global lib_data
    lib_data = {}
    col = bpy.data.collections.get(col_name)
    if col is None:
        col = bpy.data.collections.new(col_name)
    for obj in data_from.objects:
        lib_data[obj.name] = obj
        col.objects.link(obj)

    bpy.ops.object.mode_set(mode='POSE')
    add_bone_shape(reference.Pelvis, 'Cube')
    add_bone_shape(reference.Spine_0, 'Cube')


    bones = [reference.Spine_0,reference.Spine_1,reference.Spine_2,reference.Spine_3,reference.Spine_4,reference.Spine_5]

    for i in bones:
        if i != "":
            add_bone_shape(i, 'Cube')


    add_bone_shape(reference.Right_Collar, 'Collar Bone')
    add_bone_shape(reference.Left_Collar, 'Collar Bone')
    add_bone_shape(reference.Neck, 'Cube')
    add_bone_shape(reference.Head, 'Head Cube')
    add_bone_shape(reference.Left_Upper_Arm, 'Limb Bone')
    add_bone_shape(reference.Right_Upper_Arm, 'Limb Bone')
    add_bone_shape(reference.Left_Lower_Arm, 'Limb Bone')
    add_bone_shape(reference.Right_Lower_Arm, 'Limb Bone')
    add_bone_shape(reference.Left_Thigh, 'Limb Bone')
    add_bone_shape(reference.Right_Thigh, 'Limb Bone')
    add_bone_shape(reference.Left_Knee, 'Limb Bone')
    add_bone_shape(reference.Right_Knee, 'Limb Bone')
    add_bone_shape('RootTransform', 'Root Circle')
    add_bone_shape('KneeIK.L', 'Knee IK Bone')
    add_bone_shape('KneeIK.R', 'Knee IK Bone')
    add_bone_shape('FootIK.L', 'Foot IK Left')
    add_bone_shape('FootIK.R', 'Foot IK Left')
    add_bone_shape('ElbowIK.L', 'Elbow IK')
    add_bone_shape('ElbowIK.R', 'Elbow IK')
    add_bone_shape('HandIK.L', 'Hand IK Bone')
    add_bone_shape('HandIK.R', 'Hand IK Bone')
    add_bone_shape(reference.Left_Hand, 'Limb Bone')
    add_bone_shape(reference.Right_Hand, 'Limb Bone')
    add_bone_shape(reference.Left_Foot, 'Limb Bone')
    add_bone_shape(reference.Right_Foot, 'Limb Bone')

    bpy.ops.object.mode_set(mode='OBJECT')
    if reference.UseFKIKControllers:
        add_bone_shape('Arm FK/IK Controller.L', 'Arrow')
        add_bone_shape('Arm FK/IK Controller Root.L', 'Left Arm FK to IK Text')
        add_bone_shape('Arm FK/IK Controller.R', 'Arrow')
        add_bone_shape('Arm FK/IK Controller Root.R', 'Right Arm FK to IK Text')
        add_bone_shape('Leg FK/IK Controller.L', 'Arrow')
        add_bone_shape('Leg FK/IK Controller Root.L', 'Left Leg FK to IK Text')
        add_bone_shape('Leg FK/IK Controller.R', 'Arrow')
        add_bone_shape('Leg FK/IK Controller Root.R', 'Right Leg FK to IK Text')
    lib_data = None
