from pathlib import Path

import bpy
import json
import os
from os.path import abspath, dirname, join
from . import rig_fixer
from . import  auto_rigger_validator
from . import auto_rigger_settings
from . import auto_rigger_ik_limbs
from . import auto_rigger_fk_ik_controls
from . import  auto_rigger_custom_shapes
from os import path

class LoadRigFile(bpy.types.Operator):
    bl_idname = "object.load_auto_rig_file"
    bl_label = "Load Auto Rig File"

    def execute(self, context):

        # Gets the armature prop property used in the scene and the bone files
        reference = bpy.context.scene.ArmatureProp
        arm = bpy.data.objects[auto_rigger_settings.Arm_name].pose.bones
        file = bpy.path.abspath(reference.FileToLoad)

        # Retrieve the data from the json file
        with open(file) as f:
            data = json.load(f)

        for p in arm:
           for d in data.keys():
               if p.name == data[d] and data[d] != "":
                   setattr(reference,d,data[d])

        return {'FINISHED'}
