import bpy
from . import rig_fixer
from . import  auto_rigger_validator
from . import auto_rigger_settings
from . import auto_rigger_ik_limbs
from . import auto_rigger_fk_ik_controls
from . import  auto_rigger_custom_shapes


class RunAutoRigRescaler(bpy.types.Operator):
    bl_label = "Scale Auto Rigger Bone Shapes"
    bl_idname = "object.auto_rig_scale"

    def execute(self, context):
        col_name = 'R4Q Rigger Custom Bone Shapes'
        scale_name = "Scale Reference"


        ref_obj = bpy.data.objects.get(scale_name)
        if scale_name not in context.scene.objects and ref_obj is not None:
            bpy.data.objects.remove(ref_obj)
            ref_obj = bpy.data.objects.new(scale_name, None)
            context.collection.objects.link(ref_obj)
            ref_obj.empty_display_type = 'SINGLE_ARROW'
            return {'FINISHED'}
        elif ref_obj is None:
            ref_obj = bpy.data.objects.new(scale_name, None)
            context.collection.objects.link(ref_obj)
            ref_obj.empty_display_type = 'SINGLE_ARROW'
            return {'FINISHED'}
        scale_ref = ref_obj.scale
        col = bpy.data.collections.get(col_name)
        if col is None:
            self.report({'INFO'}, "No custom shapes collection, this operator only works on R4Q Rigs!")
            return {'CANCELLED'}

        for obj in col.objects:
            obj.scale = scale_ref

        override = bpy.context.copy()
        override['selected_editable_objects'] = col.objects
        bpy.ops.object.transform_apply(override, scale=True)
        return {'FINISHED'}
