import bpy

# Auto Rigger Validator: Checks to make sure the user inputted the right information before running the Auto Rig

# Checks a limb bone array to see if there are any blank entries. If it detects one, then it returns false. Otherwise
# it returns true
def validate_limb_bones(bones):
    for i in range(len(bones)):
        if bones[i] == "":
            return False
    return True


def validate_all_limb_bones():
    # Gets the bones pointer via Armature Prop
    reference = bpy.context.scene.ArmatureProp

    # Stores all of the apporiate limb bones in string arrays
    left_arm_limb_bones = [reference.Left_Hand, reference.Left_Lower_Arm, reference.Left_Upper_Arm]
    right_arm_limb_bones = [reference.Right_Hand, reference.Right_Lower_Arm, reference.Right_Upper_Arm]
    left_leg_limb_bones = [reference.Left_Foot, reference.Left_Knee, reference.Left_Thigh]
    right_leg_limb_bones = [reference.Right_Foot, reference.Right_Knee, reference.Right_Thigh]

    # Puts all of the limb bone arrays into another array
    limb_bones = [left_arm_limb_bones, right_arm_limb_bones, left_leg_limb_bones, right_leg_limb_bones]

    for i in range(len(limb_bones)):
        if validate_limb_bones(limb_bones[i]) is False:
            return False
    return True
