

def col_label(row, label):
    row.alignment = "CENTER"
    row.label(text=label)


# Gui Layout Creator: Contains several helper functions for creating the layout for Panel Guis
def create_split_box_label(box_label, layout):
    row = layout.row()
    row.alignment = "CENTER"
    row.label(text=box_label)


class GuiLayoutCreator:



    def create_horizontal_fields(self, layout, bones, reference, arm):

        row = layout.row(align=True)
        for i in range(len(bones)):
            col = row.column()
            col.label(text=bones[i])
            col.alignment = "CENTER"
            col.prop_search(reference, bones[i], arm, "bones", text="")

    def create_split_boxes(self, layout, bone_group_one, bone_group_one_label, bone_group_two, bone_group_two_label, reference, arm):

        # Creates the left column
        col = layout.row()
        split = col.split()

        box = split.column().box()

        # Creates the label for the first group
        create_split_box_label(bone_group_one_label, box)

        for i in range(len(bone_group_one)):
            row = box.row()
            row.label(text=bone_group_one[i])
            row.prop_search(reference, bone_group_one[i], arm, "bones", text="")

        box = split.column().box()

        # Creates the second label for the second group
        create_split_box_label(bone_group_two_label, box)

        for i in range(len(bone_group_two)):
            row = box.row()
            row.label(text=bone_group_two[i])
            row.prop_search(reference, bone_group_two[i], arm, "bones", text="")

